Bug 5795 - Update shipped Perl version to a recent one (currently: 5.8.4)
: Update shipped Perl version to a recent one (currently: 5.8.4)
Status: RESOLVED WONTFIX
Product: Core
general
: 5.0/(1.2009.41-10)
: N900 Linux
: Low enhancement with 3 votes (vote)
: ---
Assigned To: unassigned
: core-general-bugs
:
:
:
:
  Show dependency tree
 
Reported: 2009-10-26 13:58 UTC by pancake
Modified: 2012-03-24 11:41 UTC (History)
6 users (show)

See Also:


Attachments
Script to estimate how much package contents take from a LZO compressed file system after docs are removed (2.78 KB, text/plain)
2009-10-27 16:44 UTC, Eero Tamminen
Details


Note

You need to log in before you can comment on or make changes to this bug.


Description pancake (reporter) 2009-10-26 13:58:26 UTC
The last version of the SDK and the rootfs of maemo5 shipped with the n900 is
equipped with a perl 5.8.4.

I'm happy to see perl in the rootfs of the device, but some questions popup in
my mind.

1) Why is perl required in the rootfs?
2) Why is 5.8.4 the choosed version? Current perl is 5.10 or 5.11

I would like to see an upgraded version of perl5 in the maemo repositories.
Comment 1 Andre Klapper maemo.org 2009-10-26 15:08:06 UTC
The age of a software is not an argument.
For your questions: Feel free to use a forum. This is a bugtracker.
If there are good **reasons** for providing a newer version you are welcome to
file a request here by mentioning them.
Comment 2 maemo 2009-10-26 22:22:09 UTC
Perl 5.10 fixes these bugs:

http://search.cpan.org/dist/perl-5.10.0/pod/perl5100delta.pod#Selected_Bug_Fixes

*age* of software may not be an issue, but software not being *current*
certainly can be, since the upstream support community tends to focus on
current versions.

One ought not need to have this explained, but given the reception this bug
report has received, here it is.
Comment 3 Andre Klapper maemo.org 2009-10-26 23:04:38 UTC
(In reply to comment #2)
> One ought not need to have this explained

Maybe in a world where everybody is dealing with open source for years.
But when it comes to companies sometimes you need arguments to convince people
to do something potentially risky (e.g. switching to a new version that might
introduce new issues).
Don't get me wrong, I just play the bad cop here.

So, any specific bug fixes are you interested in...?
Comment 4 Quim Gil nokia 2009-10-27 10:33:02 UTC
I believe Eero know why Perl is there.

Look the long blog post this bug has raised.

http://www.modernperlbooks.com/mt/2009/10/how-not-to-manage-the-risk-of-perl-as-a-shipped-dependency.html
Comment 5 Andre Klapper maemo.org 2009-10-27 14:46:32 UTC
This reminded me a bit of the discussion I had internally about bug 3885
comment 10 (the liferea engine used being 5 years old and that it's a big
change to update it in the Fremantle program => considering it for Harmattan).
Hence my previous comments here, but I wasn't aware how much/less Perl is
actually used in Maemo. If it's not it should probably be easier to ship a more
recent version soon.

So which exact Perl version do you propose?
Comment 6 pancake (reporter) 2009-10-27 15:06:24 UTC
I have also noticed that the perl version shipped in maemo is incomplete, this
is, not the full perl modules of the core distribution are installed in the
rootfs, so this can be understood as a broken package.

I understand that perl is required for some debian stuff, and this is the
reason why perl is shipped in the base system. But it will be good to have ship
the whole package instead of a partially broken one.

If perl can be ignored for the rootfs I would like to have it in the apt
repository on its full version.

For the version 5.10 is stable and 5.11 is development. So 5.10 is ok
Comment 7 Eero Tamminen nokia 2009-10-27 16:44:43 UTC
Created an attachment (id=1510) [details]
Script to estimate how much package contents take from a LZO compressed file
system after docs are removed

(In reply to comment #4)
> I believe Eero know why Perl is there.

Two reasons:

* Major: It's needed by some of the dpkg scripts and used also by several other
packages in the device.

* Minor: It's a Debian essential (i.e. Debian packages are supposed to use it
without declaring a dependency and many do so). Not providing Perl would
complicate life of people needing to port stuff from Debian and increase our
delta to upstream distro.


(In reply to comment #6)
> I have also noticed that the perl version shipped in maemo is incomplete, this
> is, not the full perl modules of the core distribution are installed in the
> rootfs, so this can be understood as a broken package.

It's the "perl-base" package which in Debian is an essential (use "dpkg -L
perl-base" to see what's included into it).

"perl" package i.e. the one containing Perl modules is a huge *non-essential*
package, so anything using anything from it MUST declare their dependency on
it.  If they don't, _those_ packages are broken.


> I understand that perl is required for some debian stuff, and this is the
> reason why perl is shipped in the base system. But it will be good to have
> ship the whole package instead of a partially broken one.
>
> If perl can be ignored for the rootfs I would like to have it in the apt
> repository on its full version.

It is.  Just install it, or something depending from it.

(I mean the "perl" package containing the rest of stuff on top of "perl-base".)


> For the version 5.10 is stable and 5.11 is development. So 5.10 is ok

Too late to do that kind of updates for Fremantle unless you can demonstrate it
eating normal end users data on its own accord or something of similar
severity.  This kind of bugs should have been filed months ago when Fremantle
SDK Alpha and Beta releases were out (that's why we put them out, so that
people can comment on the release contents on time).

Could be doable in Harmattan.

NOTE: Perl-base v5.10 in Debian stable will take over 2MB[1] from the
compressed device rootfs (which in Fremantle sales release has about 100MB
free) whereas the current perl-base package takes about 1MB, less than half.


[1] This information is from the attached script for comparing the sizes of
package contents on LZO compressed file system.  It's intended mainly for
Scratchbox, but works also fine on Debian desktop if you have already "lzop"
and the package you want to investigate installed on the system.
Comment 8 Jeremiah C. Foster 2009-10-28 21:51:22 UTC
I work a little bit with the team that maintains perl in debian and am happy to
try to get an update perl installed as a package. A non-trivial task I think,
but perhaps worth trying. 

I would also like to get the Qt4 perl bindings in eventually so that people can
build perl backed applications as well. There already are clutter bindings.
Comment 9 pancake (reporter) 2009-10-30 11:57:31 UTC
That would be great! together with gtk2-perl and sdl-perl
Comment 10 Andre Klapper maemo.org 2012-03-24 11:41:59 UTC
The Maemo 5 User Interface and Maemo 5 platform components (e.g. libraries)
used for the N900 are considered stable by Nokia and it seems that there are no
plans for official updates currently, hence nobody plans to work on this
enhancement/wishlist request. 
(And in case you feel like discussing this situation: Nokia Customer Care or
http://talk.maemo.org would be the place to do so as you will not reach Nokia
officials in this community bugtracker - though all of this is really no news.)

Reflecting this status by setting RESOLVED WONTFIX for this
enhancement/wishlist request (see
https://bugs.maemo.org/page.cgi?id=fields.html#status for status explanations).

There is a small chance for issues in those Maemo components that are open
source: Contributed patches could be included and made available in the Maemo 5
Community CSSU updates. 
The Maemo CSSU project is run by a small team of volunteers; see
http://wiki.maemo.org/CSSU for more information.
So in case that you can provide a patch that fixes the reported problem, please
feel encouraged to file a request under
https://bugs.maemo.org/enter_bug.cgi?product=Maemo%205%20Community%20SSU .
Please note: The Maemo CSSU project is not related in any way to Nokia.


( Tag for mass-deleting bugmail: [cleanup20120324] )